Index: issm/trunk-jpl/src/c/Makefile.am
===================================================================
--- issm/trunk-jpl/src/c/Makefile.am	(revision 16493)
+++ issm/trunk-jpl/src/c/Makefile.am	(revision 16518)
@@ -330,12 +330,12 @@
 					./modules/Mergesolutionfromftogx/Mergesolutionfromftogx.cpp\
 					./modules/Mergesolutionfromftogx/Mergesolutionfromftogx.h\
-					./analyses/ProcessArguments.cpp\
-					./analyses/ResetBoundaryConditions.cpp\
-					./analyses/AnalysisConfiguration.cpp\
-					./analyses/WrapperCorePointerFromSolutionEnum.cpp\
-					./analyses/CorePointerFromSolutionEnum.cpp\
-					./analyses/EnvironmentInit.cpp\
-					./analyses/EnvironmentFinalize.cpp\
-					./analyses/ad_core.cpp\
+					./cores/ProcessArguments.cpp\
+					./cores/ResetBoundaryConditions.cpp\
+					./cores/AnalysisConfiguration.cpp\
+					./cores/WrapperCorePointerFromSolutionEnum.cpp\
+					./cores/CorePointerFromSolutionEnum.cpp\
+					./cores/ad_core.cpp\
+					./main/EnvironmentInit.cpp\
+					./main/EnvironmentFinalize.cpp\
 					./solutionsequences/solutionsequence_linear.cpp\
 					./solutionsequences/solutionsequence_nonlinear.cpp\
@@ -362,14 +362,14 @@
 					  ./modules/ModelProcessorx/Dakota/CreateParametersDakota.cpp\
 					  ./modules/ModelProcessorx/Dakota/UpdateElementsAndMaterialsDakota.cpp\
-					  ./analyses/dakota_core.cpp\
-					  ./analyses/DakotaSpawnCore.h\
-					  ./analyses/DakotaSpawnCore.cpp
+					  ./cores/dakota_core.cpp\
+					  ./cores/DakotaSpawnCore.h\
+					  ./cores/DakotaSpawnCore.cpp
 #}}}
 #Transient sources  {{{
 transient_sources  = ./modules/ModelProcessorx/Transient/UpdateElementsTransient.cpp \
-							./analyses/transient_core.cpp
+							./cores/transient_core.cpp
 #}}}
 #Steadystate sources  {{{
-steadystate_sources = ./analyses/steadystate_core.cpp
+steadystate_sources = ./cores/steadystate_core.cpp
 #}}}
 #Masstransport sources  {{{
@@ -394,7 +394,7 @@
 								./modules/ModelProcessorx/ExtrudeFromTop/CreateConstraintsExtrudeFromTop.cpp\
 								./modules/ModelProcessorx/ExtrudeFromTop/CreateLoadsExtrudeFromTop.cpp\
-								./analyses/masstransport_core.cpp\
-								./analyses/extrudefrombase_core.cpp\
-								./analyses/extrudefromtop_core.cpp
+								./cores/masstransport_core.cpp\
+								./cores/extrudefrombase_core.cpp\
+								./cores/extrudefromtop_core.cpp
 
 #}}}
@@ -414,5 +414,5 @@
 					   ./modules/PostprocessingEnthalpyx/PostprocessingEnthalpyx.h\
 					   ./modules/PostprocessingEnthalpyx/PostprocessingEnthalpyx.cpp\
-					   ./analyses/thermal_core.cpp\
+					   ./cores/thermal_core.cpp\
 					   ./solutionsequences/solutionsequence_thermal_nonlinear.cpp
 #}}}
@@ -460,11 +460,11 @@
 					  ./shared/Numerics/BrentSearch.cpp\
 					  ./shared/Numerics/OptimalSearch.cpp \
-					  ./analyses/control_core.cpp\
-					  ./analyses/controltao_core.cpp\
-					  ./analyses/objectivefunction.cpp\
-					  ./analyses/gradient_core.cpp\
-					  ./analyses/adjointstressbalance_core.cpp\
-					  ./analyses/adjointbalancethickness_core.cpp\
-					  ./analyses/AdjointCorePointerFromSolutionEnum.cpp\
+					  ./cores/control_core.cpp\
+					  ./cores/controltao_core.cpp\
+					  ./cores/objectivefunction.cpp\
+					  ./cores/gradient_core.cpp\
+					  ./cores/adjointstressbalance_core.cpp\
+					  ./cores/adjointbalancethickness_core.cpp\
+					  ./cores/AdjointCorePointerFromSolutionEnum.cpp\
 					  ./solutionsequences/solutionsequence_adjoint_linear.cpp
 
@@ -486,5 +486,5 @@
 							./modules/ModelProcessorx/HydrologyDCEfficient/CreateLoadsHydrologyDCEfficient.cpp \
 							./modules/ModelProcessorx/HydrologyDCEfficient/CreateParametersHydrologyDCEfficient.cpp \
-							./analyses/hydrology_core.cpp\
+							./cores/hydrology_core.cpp\
 							./solutionsequences/solutionsequence_hydro_nonlinear.cpp
 #}}}
@@ -503,5 +503,5 @@
 					      ./modules/ModelProcessorx/StressbalanceSIA/CreateConstraintsStressbalanceSIA.cpp \
 							./modules/ModelProcessorx/StressbalanceSIA/CreateLoadsStressbalanceSIA.cpp \
-							./analyses/stressbalance_core.cpp\
+							./cores/stressbalance_core.cpp\
 							./solutionsequences/solutionsequence_stokescoupling_nonlinear.cpp
 #}}}
@@ -515,7 +515,7 @@
 						 ./modules/ModelProcessorx/Balancevelocity/CreateConstraintsBalancevelocity.cpp\
 						 ./modules/ModelProcessorx/Balancevelocity/CreateLoadsBalancevelocity.cpp\
-						 ./analyses/balancethickness_core.cpp \
-						 ./analyses/balancevelocity_core.cpp \
-						 ./analyses/dummy_core.cpp
+						 ./cores/balancethickness_core.cpp \
+						 ./cores/balancevelocity_core.cpp \
+						 ./cores/dummy_core.cpp
 #}}}
 #Slope sources  {{{
@@ -528,6 +528,6 @@
 					  ./modules/ModelProcessorx/SurfaceSlope/CreateConstraintsSurfaceSlope.cpp\
 					  ./modules/ModelProcessorx/SurfaceSlope/CreateLoadsSurfaceSlope.cpp\
-					  ./analyses/surfaceslope_core.cpp\
-					  ./analyses/bedslope_core.cpp
+					  ./cores/surfaceslope_core.cpp\
+					  ./cores/bedslope_core.cpp
 #}}}
 #MeshDeformation sources  {{{
@@ -536,8 +536,8 @@
 					  ./modules/ModelProcessorx/MeshDeformation/CreateConstraintsMeshDeformation.cpp\
 					  ./modules/ModelProcessorx/MeshDeformation/CreateLoadsMeshDeformation.cpp\
-					  ./analyses/meshdeformation_core.cpp
+					  ./cores/meshdeformation_core.cpp
 #}}}
 #Gia sources  {{{
-gia_sources =  ./analyses/gia_core.cpp\
+gia_sources =  ./cores/gia_core.cpp\
 					./modules/ModelProcessorx/Gia/UpdateElementsGia.cpp\
 					./modules/ModelProcessorx/Gia/CreateNodesGia.cpp \
@@ -557,5 +557,5 @@
 #}}}
 #Damage sources  {{{
-damage_sources =  ./analyses/damage_core.cpp\
+damage_sources =  ./cores/damage_core.cpp\
 					./modules/ModelProcessorx/Damage/UpdateElementsDamage.cpp\
 					./modules/ModelProcessorx/Damage/CreateNodesDamage.cpp \