Index: issm/trunk-jpl/src/c/analyses/AdjointBalancethicknessAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/AdjointBalancethicknessAnalysis.cpp	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/AdjointBalancethicknessAnalysis.cpp	(revision 17005)
@@ -26,4 +26,7 @@
 
 /*Finite Element Analysis*/
+void           AdjointBalancethicknessAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* AdjointBalancethicknessAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
Index: issm/trunk-jpl/src/c/analyses/AdjointBalancethicknessAnalysis.h
===================================================================
--- issm/trunk-jpl/src/c/analyses/AdjointBalancethicknessAnalysis.h	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/AdjointBalancethicknessAnalysis.h	(revision 17005)
@@ -21,4 +21,5 @@
 
 		/*Finite element Analysis*/
+		void           Core(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk-jpl/src/c/analyses/AdjointHorizAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/AdjointHorizAnalysis.cpp	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/AdjointHorizAnalysis.cpp	(revision 17005)
@@ -26,4 +26,7 @@
 
 /*Finite Element Analysis*/
+void           AdjointHorizAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* AdjointHorizAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
Index: issm/trunk-jpl/src/c/analyses/AdjointHorizAnalysis.h
===================================================================
--- issm/trunk-jpl/src/c/analyses/AdjointHorizAnalysis.h	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/AdjointHorizAnalysis.h	(revision 17005)
@@ -21,4 +21,5 @@
 
 		/*Finite element Analysis*/
+		void           Core(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk-jpl/src/c/analyses/BalancethicknessAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/BalancethicknessAnalysis.cpp	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/BalancethicknessAnalysis.cpp	(revision 17005)
@@ -114,4 +114,7 @@
 
 /*Finite Element Analysis*/
+void           BalancethicknessAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* BalancethicknessAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
Index: issm/trunk-jpl/src/c/analyses/BalancethicknessAnalysis.h
===================================================================
--- issm/trunk-jpl/src/c/analyses/BalancethicknessAnalysis.h	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/BalancethicknessAnalysis.h	(revision 17005)
@@ -21,4 +21,5 @@
 
 		/*Finite element Analysis*/
+		void           Core(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk-jpl/src/c/analyses/BalancethicknessSoftAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/BalancethicknessSoftAnalysis.cpp	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/BalancethicknessSoftAnalysis.cpp	(revision 17005)
@@ -26,4 +26,7 @@
 
 /*Finite Element Analysis*/
+void           BalancethicknessSoftAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* BalancethicknessSoftAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
Index: issm/trunk-jpl/src/c/analyses/BalancethicknessSoftAnalysis.h
===================================================================
--- issm/trunk-jpl/src/c/analyses/BalancethicknessSoftAnalysis.h	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/BalancethicknessSoftAnalysis.h	(revision 17005)
@@ -21,4 +21,5 @@
 
 		/*Finite element Analysis*/
+		void           Core(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk-jpl/src/c/analyses/BalancevelocityAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/BalancevelocityAnalysis.cpp	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/BalancevelocityAnalysis.cpp	(revision 17005)
@@ -59,4 +59,7 @@
 
 /*Finite Element Analysis*/
+void           BalancevelocityAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* BalancevelocityAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
Index: issm/trunk-jpl/src/c/analyses/BalancevelocityAnalysis.h
===================================================================
--- issm/trunk-jpl/src/c/analyses/BalancevelocityAnalysis.h	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/BalancevelocityAnalysis.h	(revision 17005)
@@ -21,4 +21,5 @@
 
 		/*Finite element Analysis*/
+		void           Core(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk-jpl/src/c/analyses/DamageEvolutionAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/DamageEvolutionAnalysis.cpp	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/DamageEvolutionAnalysis.cpp	(revision 17005)
@@ -95,4 +95,7 @@
 
 /*Finite Element Analysis*/
+void           DamageEvolutionAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* DamageEvolutionAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
Index: issm/trunk-jpl/src/c/analyses/DamageEvolutionAnalysis.h
===================================================================
--- issm/trunk-jpl/src/c/analyses/DamageEvolutionAnalysis.h	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/DamageEvolutionAnalysis.h	(revision 17005)
@@ -21,4 +21,5 @@
 
 		/*Finite element Analysis*/
+		void           Core(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk-jpl/src/c/analyses/EnthalpyAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/EnthalpyAnalysis.cpp	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/EnthalpyAnalysis.cpp	(revision 17005)
@@ -184,4 +184,7 @@
 
 /*Finite Element Analysis*/
+void           EnthalpyAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* EnthalpyAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
Index: issm/trunk-jpl/src/c/analyses/EnthalpyAnalysis.h
===================================================================
--- issm/trunk-jpl/src/c/analyses/EnthalpyAnalysis.h	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/EnthalpyAnalysis.h	(revision 17005)
@@ -21,4 +21,5 @@
 
 		/*Finite element Analysis*/
+		void           Core(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk-jpl/src/c/analyses/EnumToAnalysis.h
===================================================================
--- issm/trunk-jpl/src/c/analyses/EnumToAnalysis.h	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/EnumToAnalysis.h	(revision 17005)
@@ -16,4 +16,5 @@
 
 		/*Finite element Analysis*/
+		void           Core(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk-jpl/src/c/analyses/ExtrudeFromBaseAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/ExtrudeFromBaseAnalysis.cpp	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/ExtrudeFromBaseAnalysis.cpp	(revision 17005)
@@ -37,4 +37,7 @@
 
 /*Finite Element Analysis*/
+void           ExtrudeFromBaseAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* ExtrudeFromBaseAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
Index: issm/trunk-jpl/src/c/analyses/ExtrudeFromBaseAnalysis.h
===================================================================
--- issm/trunk-jpl/src/c/analyses/ExtrudeFromBaseAnalysis.h	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/ExtrudeFromBaseAnalysis.h	(revision 17005)
@@ -21,4 +21,5 @@
 
 		/*Finite element Analysis*/
+		void           Core(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk-jpl/src/c/analyses/ExtrudeFromTopAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/ExtrudeFromTopAnalysis.cpp	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/ExtrudeFromTopAnalysis.cpp	(revision 17005)
@@ -37,4 +37,7 @@
 
 /*Finite Element Analysis*/
+void           ExtrudeFromTopAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* ExtrudeFromTopAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
Index: issm/trunk-jpl/src/c/analyses/ExtrudeFromTopAnalysis.h
===================================================================
--- issm/trunk-jpl/src/c/analyses/ExtrudeFromTopAnalysis.h	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/ExtrudeFromTopAnalysis.h	(revision 17005)
@@ -21,4 +21,5 @@
 
 		/*Finite element Analysis*/
+		void           Core(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk-jpl/src/c/analyses/FreeSurfaceBaseAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/FreeSurfaceBaseAnalysis.cpp	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/FreeSurfaceBaseAnalysis.cpp	(revision 17005)
@@ -90,4 +90,7 @@
 
 /*Finite Element Analysis*/
+void           FreeSurfaceBaseAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* FreeSurfaceBaseAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
Index: issm/trunk-jpl/src/c/analyses/FreeSurfaceBaseAnalysis.h
===================================================================
--- issm/trunk-jpl/src/c/analyses/FreeSurfaceBaseAnalysis.h	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/FreeSurfaceBaseAnalysis.h	(revision 17005)
@@ -21,4 +21,5 @@
 
 		/*Finite element Analysis*/
+		void           Core(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk-jpl/src/c/analyses/FreeSurfaceTopAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/FreeSurfaceTopAnalysis.cpp	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/FreeSurfaceTopAnalysis.cpp	(revision 17005)
@@ -88,4 +88,7 @@
 
 /*Finite Element Analysis*/
+void           FreeSurfaceTopAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* FreeSurfaceTopAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
Index: issm/trunk-jpl/src/c/analyses/FreeSurfaceTopAnalysis.h
===================================================================
--- issm/trunk-jpl/src/c/analyses/FreeSurfaceTopAnalysis.h	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/FreeSurfaceTopAnalysis.h	(revision 17005)
@@ -21,4 +21,5 @@
 
 		/*Finite element Analysis*/
+		void           Core(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk-jpl/src/c/analyses/GiaAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/GiaAnalysis.cpp	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/GiaAnalysis.cpp	(revision 17005)
@@ -38,4 +38,7 @@
 
 /*Finite Element Analysis*/
+void           GiaAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* GiaAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
Index: issm/trunk-jpl/src/c/analyses/GiaAnalysis.h
===================================================================
--- issm/trunk-jpl/src/c/analyses/GiaAnalysis.h	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/GiaAnalysis.h	(revision 17005)
@@ -21,4 +21,5 @@
 
 		/*Finite element Analysis*/
+		void           Core(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk-jpl/src/c/analyses/HydrologyDCEfficientAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/HydrologyDCEfficientAnalysis.cpp	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/HydrologyDCEfficientAnalysis.cpp	(revision 17005)
@@ -96,4 +96,7 @@
 
 /*Finite Element Analysis*/
+void           HydrologyDCEfficientAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* HydrologyDCEfficientAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
Index: issm/trunk-jpl/src/c/analyses/HydrologyDCEfficientAnalysis.h
===================================================================
--- issm/trunk-jpl/src/c/analyses/HydrologyDCEfficientAnalysis.h	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/HydrologyDCEfficientAnalysis.h	(revision 17005)
@@ -21,4 +21,5 @@
 
 		/*Finite element Analysis*/
+		void           Core(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk-jpl/src/c/analyses/HydrologyDCInefficientAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/HydrologyDCInefficientAnalysis.cpp	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/HydrologyDCInefficientAnalysis.cpp	(revision 17005)
@@ -137,4 +137,7 @@
 
 /*Finite Element Analysis*/
+void           HydrologyDCInefficientAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* HydrologyDCInefficientAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
Index: issm/trunk-jpl/src/c/analyses/HydrologyDCInefficientAnalysis.h
===================================================================
--- issm/trunk-jpl/src/c/analyses/HydrologyDCInefficientAnalysis.h	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/HydrologyDCInefficientAnalysis.h	(revision 17005)
@@ -21,4 +21,5 @@
 
 		/*Finite element Analysis*/
+		void           Core(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk-jpl/src/c/analyses/HydrologyShreveAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/HydrologyShreveAnalysis.cpp	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/HydrologyShreveAnalysis.cpp	(revision 17005)
@@ -82,4 +82,7 @@
 
 /*Finite Element Analysis*/
+void           HydrologyShreveAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* HydrologyShreveAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
Index: issm/trunk-jpl/src/c/analyses/HydrologyShreveAnalysis.h
===================================================================
--- issm/trunk-jpl/src/c/analyses/HydrologyShreveAnalysis.h	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/HydrologyShreveAnalysis.h	(revision 17005)
@@ -21,4 +21,5 @@
 
 		/*Finite element Analysis*/
+		void           Core(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk-jpl/src/c/analyses/L2ProjectionBaseAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/L2ProjectionBaseAnalysis.cpp	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/L2ProjectionBaseAnalysis.cpp	(revision 17005)
@@ -55,4 +55,7 @@
 
 /*Finite Element Analysis*/
+void           L2ProjectionBaseAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* L2ProjectionBaseAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
Index: issm/trunk-jpl/src/c/analyses/L2ProjectionBaseAnalysis.h
===================================================================
--- issm/trunk-jpl/src/c/analyses/L2ProjectionBaseAnalysis.h	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/L2ProjectionBaseAnalysis.h	(revision 17005)
@@ -21,4 +21,5 @@
 
 		/*Finite element Analysis*/
+		void           Core(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk-jpl/src/c/analyses/L2ProjectionEPLAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/L2ProjectionEPLAnalysis.cpp	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/L2ProjectionEPLAnalysis.cpp	(revision 17005)
@@ -70,4 +70,7 @@
 
 /*Finite Element Analysis*/
+void           L2ProjectionEPLAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* L2ProjectionEPLAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
Index: issm/trunk-jpl/src/c/analyses/L2ProjectionEPLAnalysis.h
===================================================================
--- issm/trunk-jpl/src/c/analyses/L2ProjectionEPLAnalysis.h	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/L2ProjectionEPLAnalysis.h	(revision 17005)
@@ -21,4 +21,5 @@
 
 		/*Finite element Analysis*/
+		void           Core(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk-jpl/src/c/analyses/MasstransportAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/MasstransportAnalysis.cpp	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/MasstransportAnalysis.cpp	(revision 17005)
@@ -212,4 +212,7 @@
 
 /*Finite Element Analysis*/
+void           MasstransportAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* MasstransportAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
Index: issm/trunk-jpl/src/c/analyses/MasstransportAnalysis.h
===================================================================
--- issm/trunk-jpl/src/c/analyses/MasstransportAnalysis.h	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/MasstransportAnalysis.h	(revision 17005)
@@ -21,4 +21,5 @@
 
 		/*Finite element Analysis*/
+		void           Core(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk-jpl/src/c/analyses/MeltingAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/MeltingAnalysis.cpp	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/MeltingAnalysis.cpp	(revision 17005)
@@ -72,4 +72,7 @@
 
 /*Finite Element Analysis*/
+void           MeltingAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* MeltingAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
Index: issm/trunk-jpl/src/c/analyses/MeltingAnalysis.h
===================================================================
--- issm/trunk-jpl/src/c/analyses/MeltingAnalysis.h	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/MeltingAnalysis.h	(revision 17005)
@@ -21,4 +21,5 @@
 
 		/*Finite element Analysis*/
+		void           Core(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk-jpl/src/c/analyses/MeshdeformationAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/MeshdeformationAnalysis.cpp	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/MeshdeformationAnalysis.cpp	(revision 17005)
@@ -26,4 +26,7 @@
 
 /*Finite Element Analysis*/
+void           MeshdeformationAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* MeshdeformationAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
Index: issm/trunk-jpl/src/c/analyses/MeshdeformationAnalysis.h
===================================================================
--- issm/trunk-jpl/src/c/analyses/MeshdeformationAnalysis.h	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/MeshdeformationAnalysis.h	(revision 17005)
@@ -21,4 +21,5 @@
 
 		/*Finite element Analysis*/
+		void           Core(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk-jpl/src/c/analyses/SmoothedSurfaceSlopeXAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/SmoothedSurfaceSlopeXAnalysis.cpp	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/SmoothedSurfaceSlopeXAnalysis.cpp	(revision 17005)
@@ -45,4 +45,7 @@
 
 /*Finite Element Analysis*/
+void           SmoothedSurfaceSlopeXAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* SmoothedSurfaceSlopeXAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
Index: issm/trunk-jpl/src/c/analyses/SmoothedSurfaceSlopeXAnalysis.h
===================================================================
--- issm/trunk-jpl/src/c/analyses/SmoothedSurfaceSlopeXAnalysis.h	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/SmoothedSurfaceSlopeXAnalysis.h	(revision 17005)
@@ -21,4 +21,5 @@
 
 		/*Finite element Analysis*/
+		void           Core(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk-jpl/src/c/analyses/SmoothedSurfaceSlopeYAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/SmoothedSurfaceSlopeYAnalysis.cpp	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/SmoothedSurfaceSlopeYAnalysis.cpp	(revision 17005)
@@ -45,4 +45,7 @@
 
 /*Finite Element Analysis*/
+void           SmoothedSurfaceSlopeYAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* SmoothedSurfaceSlopeYAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
Index: issm/trunk-jpl/src/c/analyses/SmoothedSurfaceSlopeYAnalysis.h
===================================================================
--- issm/trunk-jpl/src/c/analyses/SmoothedSurfaceSlopeYAnalysis.h	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/SmoothedSurfaceSlopeYAnalysis.h	(revision 17005)
@@ -21,4 +21,5 @@
 
 		/*Finite element Analysis*/
+		void           Core(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk-jpl/src/c/analyses/StressbalanceAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/StressbalanceAnalysis.cpp	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/StressbalanceAnalysis.cpp	(revision 17005)
@@ -812,4 +812,7 @@
 
 /*Finite Element Analysis*/
+void           StressbalanceAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* StressbalanceAnalysis::CreateDVector(Element* element){/*{{{*/
 
Index: issm/trunk-jpl/src/c/analyses/StressbalanceAnalysis.h
===================================================================
--- issm/trunk-jpl/src/c/analyses/StressbalanceAnalysis.h	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/StressbalanceAnalysis.h	(revision 17005)
@@ -21,4 +21,5 @@
 
 		/*Finite element Analysis*/
+		void           Core(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk-jpl/src/c/analyses/StressbalanceSIAAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/StressbalanceSIAAnalysis.cpp	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/StressbalanceSIAAnalysis.cpp	(revision 17005)
@@ -135,4 +135,7 @@
 
 /*Finite Element Analysis*/
+void           StressbalanceSIAAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* StressbalanceSIAAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
Index: issm/trunk-jpl/src/c/analyses/StressbalanceSIAAnalysis.h
===================================================================
--- issm/trunk-jpl/src/c/analyses/StressbalanceSIAAnalysis.h	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/StressbalanceSIAAnalysis.h	(revision 17005)
@@ -21,4 +21,5 @@
 
 		/*Finite element Analysis*/
+		void           Core(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk-jpl/src/c/analyses/StressbalanceVerticalAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/StressbalanceVerticalAnalysis.cpp	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/StressbalanceVerticalAnalysis.cpp	(revision 17005)
@@ -96,4 +96,7 @@
 
 /*Finite Element Analysis*/
+void           StressbalanceVerticalAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* StressbalanceVerticalAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
Index: issm/trunk-jpl/src/c/analyses/StressbalanceVerticalAnalysis.h
===================================================================
--- issm/trunk-jpl/src/c/analyses/StressbalanceVerticalAnalysis.h	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/StressbalanceVerticalAnalysis.h	(revision 17005)
@@ -21,4 +21,5 @@
 
 		/*Finite element Analysis*/
+		void           Core(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk-jpl/src/c/analyses/ThermalAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/ThermalAnalysis.cpp	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/ThermalAnalysis.cpp	(revision 17005)
@@ -112,4 +112,7 @@
 
 /*Finite Element Analysis*/
+void           ThermalAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* ThermalAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
Index: issm/trunk-jpl/src/c/analyses/ThermalAnalysis.h
===================================================================
--- issm/trunk-jpl/src/c/analyses/ThermalAnalysis.h	(revision 17004)
+++ issm/trunk-jpl/src/c/analyses/ThermalAnalysis.h	(revision 17005)
@@ -21,4 +21,5 @@
 
 		/*Finite element Analysis*/
+		void           Core(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);